package cc.fascinated.bat.command.impl;

import cc.fascinated.bat.command.BatCommand;
import cc.fascinated.bat.model.BatGuild;
import cc.fascinated.bat.model.BatUser;
import cc.fascinated.bat.service.DiscordService;
import lombok.NonNull;
import net.dv8tion.jda.api.entities.Member;
import net.dv8tion.jda.api.entities.channel.concrete.TextChannel;
import net.dv8tion.jda.api.interactions.commands.SlashCommandInteraction;
import net.dv8tion.jda.internal.interactions.CommandDataImpl;
import org.springframework.stereotype.Component;

/**
 * @author Fascinated (fascinated7)
 */
@Component
public class PingCommand extends BatCommand {

    public PingCommand() {
        super("ping");
        super.setDescription("Gets the ping of the bot");
        super.setCommandData(new CommandDataImpl(this.getName(), this.getDescription()));
    }

    @Override
    public void execute(@NonNull BatGuild guild, @NonNull BatUser user, @NonNull TextChannel channel, @NonNull Member member, @NonNull SlashCommandInteraction interaction) {
        long time = System.currentTimeMillis();
        interaction.reply("Pinging...").queue(response -> {
            response.editOriginal(("Gateway response time: `%sms`\nAPI response time `%sms`").formatted(
                    DiscordService.JDA.getGatewayPing(),
                            System.currentTimeMillis() - time
            )).queue();
        });
    }
}
