package cc.fascinated.bat.features.scoresaber.command.scoresaber;

import cc.fascinated.bat.command.BatSubCommand;
import cc.fascinated.bat.common.EmbedUtils;
import cc.fascinated.bat.model.BatGuild;
import cc.fascinated.bat.model.BatUser;
import cc.fascinated.bat.service.ScoreSaberService;
import cc.fascinated.bat.service.UserService;
import lombok.NonNull;
import net.dv8tion.jda.api.entities.Member;
import net.dv8tion.jda.api.entities.channel.concrete.TextChannel;
import net.dv8tion.jda.api.interactions.commands.OptionMapping;
import net.dv8tion.jda.api.interactions.commands.SlashCommandInteraction;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 * @author Fascinated (fascinated7)
 */
@Component("scoresaber:user.sub")
public class UserSubCommand extends BatSubCommand {
    private final ScoreSaberService scoreSaberService;
    private final UserService userService;

    @Autowired
    public UserSubCommand(@NonNull ScoreSaberService scoreSaberService, @NonNull UserService userService) {
        this.scoreSaberService = scoreSaberService;
        this.userService = userService;
    }

    @Override
    public void execute(@NonNull BatGuild guild, @NonNull BatUser user, @NonNull TextChannel channel, @NonNull Member member, @NonNull SlashCommandInteraction interaction) {
        OptionMapping option = interaction.getOption("user");
        if (option == null) {
            interaction.replyEmbeds(EmbedUtils.buildErrorEmbed("Please provide a user to view the ScoreSaber profile of").build()).queue();
            return;
        }

        if (option.getAsUser().isBot()) {
            interaction.replyEmbeds(EmbedUtils.buildErrorEmbed("You cannot view the ScoreSaber profile for a Bot").build()).queue();
            return;
        }

        BatUser target = userService.getUser(option.getAsUser().getId());
        if (target == null) {
            interaction.replyEmbeds(EmbedUtils.buildErrorEmbed("Unknown user").build()).queue();
            return;
        }
        ScoreSaberCommand.sendProfileEmbed(false, target, scoreSaberService, interaction);
    }
}
