package cc.fascinated.bat.model.beatsaber.scoresaber;

import lombok.Getter;
import lombok.ToString;

import java.util.List;

@Getter @ToString
public class ScoreSaberLeaderboardToken {
    /**
     * The ID of the leaderboard.
     */
    private String id;

    /**
     * The hash of the song.
     */
    private String songHash;

    /**
     * The name of the song.
     */
    private String songName;

    /**
     * The sub name of the song.
     */
    private String songSubName;

    /**
     * The author of the song.
     */
    private String songAuthorName;

    /**
     * The mapper of the song.
     */
    private String levelAuthorName;

    /**
     * The difficulty of the song.
     */
    private Difficulty difficulty;

    /**
     * The maximum score of the song.
     */
    private int maxScore;

    /**
     * The date the leaderboard was created.
     */
    private String createdDate;

    /**
     * The date the song was ranked.
     */
    private String rankedDate;

    /**
     * The date the song was qualified.
     */
    private String qualifiedDate;

    /**
     * The date the song's status was changed to loved.
     */
    private String lovedDate;

    /**
     * Whether this leaderboard is ranked.
     */
    private boolean ranked;

    /**
     * Whether this leaderboard is qualified to be ranked.
     */
    private boolean qualified;

    /**
     * Whether this leaderboard is in a loved state.
     */
    private boolean loved;

    /**
     * The maximum PP for this leaderboard.
     */
    private int maxPP;

    /**
     * The star rating for this leaderboard.
     */
    private double stars;

    /**
     * The amount of plays for this leaderboard.
     */
    private int plays;

    /**
     * The amount of daily plays for this leaderboard.
     */
    private int dailyPlays;

    /**
     * Whether this leaderboard has positive modifiers.
     */
    private boolean positiveModifiers;

    /**
     * The cover image for this leaderboard.
     */
    private String coverImage;

    /**
     * The difficulties for this leaderboard.
     */
    private List<Difficulty> difficulties;

    /**
     * The difficulty of the leaderboard.
     */
    @Getter
    public static class Difficulty {
        /**
         * The leaderboard ID.
         */
        private int leaderboardId;

        /**
         * The difficulty of the leaderboard.
         */
        private int difficulty;

        /**
         * The game mode of the leaderboard.
         */
        private String gameMode;

        /**
         * The difficulty raw of the leaderboard.
         */
        private String difficultyRaw;
    }
}
